package com.huake.demo.common;

import com.huake.demo.entity.Dlx;
import com.huake.demo.entity.Dlxurl;
import com.huake.demo.service.UserService;
import com.huake.demo.service.dlxService;
import com.huake.demo.service.dlxurlService;
import org.apache.log4j.Logger;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;

@Component
public class login {
    @Autowired
    private UserService userService;

    @Autowired
    private com.huake.demo.service.dlxService dlxService;

    @Autowired
    private MultiSiteLoginAutomation ysqd;

    @Autowired
    private com.huake.demo.service.dlxurlService dlxurlService;

    private static final Logger logger = Logger.getLogger(login.class);


    @PostConstruct
    public void init() throws InterruptedException {
        getUrl();
        jb();
    }


    @Scheduled(cron = "0 20 2,10,11,14,17,21 * * ?")
    @Scheduled(cron = "0 50 23 * * ?")
    public void jb() throws InterruptedException {
        LocalDateTime now = LocalDateTime.now();
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        String formattedDateTime = now.format(formatter);
        logger.info("原神启动！");
        logger.info("当前时间："+formattedDateTime);
        List<Dlx> dlxes = dlxService.selectAll();
        Dlxurl dlxurl = dlxurlService.selectAll();
        for (Dlx dlx : dlxes) {
            ysqd.runAutomation(dlxurl,dlx);
        }
        logger.info("脚本执行成功");
    }


    @Scheduled(cron = "0 0/30 * * * ?")
    private void getUrl(){
        try {
            JSONObject result = fetchJsonData("http://qsbdt.com/geturl.json");

            // 单独获取每一条数据
            String kyUrl = result.getString("kyurl");
            String hthUrl = result.getString("hthurl");
            String jyUrl = result.getString("jyurl");
            logger.info("最新链接为："+result.toString(2));
            Dlxurl dlxurl = new Dlxurl();
            dlxurl.setKyurl(kyUrl);
            dlxurl.setHthurl(hthUrl);
            dlxurl.setJyurl(jyUrl);
            int i = dlxurlService.updateUrl(dlxurl);
            logger.info("最新链接为："+result.toString(2));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static JSONObject fetchJsonData(String urlString) {
        try {
            URL url = new URL(urlString);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestMethod("GET");
            conn.setConnectTimeout(5000);
            conn.setReadTimeout(5000);

            // 检查响应代码
            if (conn.getResponseCode() != 200) {
                throw new RuntimeException("Failed: HTTP error code: " + conn.getResponseCode());
            }

            // 读取响应
            BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            StringBuilder response = new StringBuilder();
            String inputLine;

            while ((inputLine = in.readLine()) != null) {
                response.append(inputLine);
            }
            in.close();

            // 返回JSONObject
            return new JSONObject(response.toString());

        } catch (Exception e) {
            e.printStackTrace();
            return null; // 出现异常时返回null
        }
    }

}
