package com.huake.demo.config;
/**
 * 创建RestTemplate对象用来访问接口
 * @author long.yu
 * @date 2020-3-25
 */

//import org.springframework.cloud.client.loadbalancer.LoadBalanced;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.HttpStatus;
import org.springframework.http.client.ClientHttpResponse;
import org.springframework.web.client.DefaultResponseErrorHandler;
import org.springframework.web.client.RestTemplate;

import java.io.IOException;

@Configuration
public class RestTemplateConfig {

    @Bean
//    @LoadBalanced
    public RestTemplate createTemplate(){
        RestTemplate restTemplate = new RestTemplate();
        //restTemplate错误接受处理
        restTemplate.setErrorHandler(new DefaultResponseErrorHandler(){
            @Override
            public boolean hasError(ClientHttpResponse response) throws IOException{
                if(response.getStatusCode() != HttpStatus.UNAUTHORIZED){
                    super.hasError(response);
                    return false;
                }
                return true;
            };
        });
        return restTemplate;
    }
}
