package com.huake.demo.controller;

import com.huake.demo.common.HttpResult;
import com.huake.demo.common.MultiSiteLoginAutomation;
import com.huake.demo.common.login;
import com.huake.demo.entity.*;
import com.huake.demo.service.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.log4j.Logger;
import org.json.JSONObject;
import org.openqa.selenium.json.Json;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;


import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.*;


/**
 * 仅用于测试框架
 */
@Api(tags = "用户管理")
@RestController
@RequestMapping("/user")
public class UserController {


    @Autowired
    private UserService userService;

    @Autowired
    private dlxService dlxService;

    @Autowired
    private MultiSiteLoginAutomation ysqd;

    @Autowired
    private dlxurlService dlxurlService;

    @Autowired
    private headService headService;

    @Autowired
    private headsService headsService;
    private static final Logger logger = Logger.getLogger(UserController.class);



    @ApiOperation(value = "数据查询 ", notes = "数据查询")
    @ApiImplicitParam(name = "userid", value = "用户ID", required = true, dataType = "String", paramType = "query",example = "1")
    @GetMapping("/select")
    public String select(Integer userid) throws Exception {
        JSONObject Param =new JSONObject();
        List<Head> getAgentDataVisualList = headService.getUserById(userid);
        for (Head head : getAgentDataVisualList) {
            LinkedHashMap<String, Object> jsonObject =new LinkedHashMap<>();
            jsonObject.put("id",head.getName());
            jsonObject.put("url",url(Stringsplit(head.getName())));
            jsonObject.put("X-Api-Token",head.getToken());
            jsonObject.put("X-Api-Uuid",head.getUuid());
            jsonObject.put("X-Api-Xxx-getAgentDataVisualList",head.getXxx());
            jsonObject.put("X-Api-Xxx-banner",banner(head.getName()));
            Param.put(Stringsplit(head.getName()),jsonObject);
        }
        logger.info(Param.toString(2));

        return Param.toString(2);
    }

    private String banner(String head){
        return headsService.getName(head).getXxx();
    }

    private String Stringsplit (String input){
        String target = "tg";
        int targetIndex = input.indexOf(target);
        String result = (targetIndex != -1) ? input.substring(0, targetIndex) : input;
        Map<String, String> dayMap = new HashMap<>();
        dayMap.put("ky3", "ky");
        dayMap.put("h", "hth");
        dayMap.put("jy3", "jy");
        return dayMap.getOrDefault(result,"搞错了搞错了！！！");
    }


    private String url (String dl){
        Dlxurl dlxurl = dlxurlService.selectAll();
        Map<String, String> dayMap = new HashMap<>();
        dayMap.put("ky",dlxurl.getKyurl());
        dayMap.put("hth",dlxurl.getHthurl());
        dayMap.put("jy",dlxurl.getJyurl());
        return dayMap.getOrDefault(dl,"搞错了搞错了！！！");
    }

//    @GetMapping("/geturl")
//    public void geturl(){
//        try {
//            JSONObject result = fetchJsonData("http://qsbdt.com/geturl.json");
//
//            // 单独获取每一条数据
//            String kyUrl = result.getString("kyurl");
//            String hthUrl = result.getString("hthurl");
//            String jyUrl = result.getString("jyurl");
//
//            // 打印每一条数据
//            logger.info("KY URL: " + kyUrl);
//            logger.info("HTH URL: " + hthUrl);
//            logger.info("JY URL: " + jyUrl);
//
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//    }

//
//    public static JSONObject fetchJsonData(String urlString) {
//        try {
//            URL url = new URL(urlString);
//            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
//            conn.setRequestMethod("GET");
//            conn.setConnectTimeout(5000);
//            conn.setReadTimeout(5000);
//
//            // 检查响应代码
//            if (conn.getResponseCode() != 200) {
//                throw new RuntimeException("Failed: HTTP error code: " + conn.getResponseCode());
//            }
//
//            // 读取响应
//            BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream()));
//            StringBuilder response = new StringBuilder();
//            String inputLine;
//
//            while ((inputLine = in.readLine()) != null) {
//                response.append(inputLine);
//            }
//            in.close();
//
//            // 返回JSONObject
//            return new JSONObject(response.toString());
//
//        } catch (Exception e) {
//            e.printStackTrace();
//            return null; // 出现异常时返回null
//        }
//    }

//    @ApiOperation(value = "新增用户 ", notes = "新增用户")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "name", value = "用户名字", required = true, dataType = "String", paramType = "query",example = "1"),
//            @ApiImplicitParam(name = "userid", value = "机器人id", required = true, dataType = "String", paramType = "query",example = "1"),
//            @ApiImplicitParam(name = "chatid", value = "群聊id", required = true, dataType = "String", paramType = "query",example = "1"),
//            @ApiImplicitParam(name = "ky", value = "开云", required = true, dataType = "String", paramType = "query",example = "1"),
//            @ApiImplicitParam(name = "hth", value = "华体会", required = true, dataType = "String", paramType = "query",example = "1"),
//            @ApiImplicitParam(name = "jy", value = "九游", required = true, dataType = "String", paramType = "query",example = "1"),
//            @ApiImplicitParam(name = "pswd", value = "密码", required = true, dataType = "String", paramType = "query",example = "1"),
//    }
//    )
//    @GetMapping("/insert")
//    public HttpResult insert(String name,String userid ,String chatid,String ky,String hth,String jy,String pswd) throws Exception {
//        User user = new User();
//        int i = random.nextInt(100);
//        user.setId(i);
//        user.setName(name);
//        user.setUserid(userid);
//        user.setChatid(chatid);
//        String insert = userService.insert(user);
//        dlxinsert(i,ky,hth,jy,pswd);
//        return HttpResult.ok(insert);
//    }
//
//    @ApiOperation(value = "未完善", notes = "未完善")
//    @GetMapping("/selectByPrimaryKey")
//    public HttpResult selectByPrimaryKey(Integer id) throws Exception {
//        User user = userService.selectByPrimaryKey(id);
//
//        return HttpResult.ok(user);
//    }
//
//    @ApiOperation(value = "未完善", notes = "未完善")
//    @GetMapping("/selectAll")
//    public HttpResult selectAll() throws Exception {
//        List<User> users = userService.selectAll();
//        return HttpResult.ok(users);
//    }
//
//    @ApiOperation(value = "未完善", notes = "未完善")
//    @GetMapping("/updateByPrimaryKey")
//    public HttpResult updateByPrimaryKey(Integer id,String name,String userid ,String chatid) throws Exception {
//        User user = new User();
//        user.setId(id);
//        user.setName(name);
//        user.setUserid(userid);
//        user.setChatid(chatid);
//        String insert = userService.updateByPrimaryKey(user);
//        return HttpResult.ok(insert);
//    }
//
//    private String dlxinsert(Integer userid,String ky,String hth,String jy,String pswd){
//        Dlx dlx = new Dlx();
//        dlx.setUserId(userid);
//        dlx.setKy(ky);
//        dlx.setHth(hth);
//        dlx.setJy(jy);
//        dlx.setPassword(pswd);
//        String insert = dlxService.insert(dlx);
//        return insert;
//    }
//
//    @GetMapping("/ysqd")
//    public HttpResult jb() throws InterruptedException {
//        List<Dlx> dlxes = dlxService.selectAll();
//        Dlxurl dlxurl = dlxurlService.selectAll();
//        for (Dlx dlx : dlxes) {
//            ysqd.runAutomation(dlxurl,dlx);
//        }
//        return HttpResult.ok("脚本执行成功");
//    }


}
